%
clear
clc
M=1000;
w=0;
W=[];
n=200; 
m=40;

for i=1:m
     p(i)=random('uniform',0.03,0.05); % MAF
end

for k=1:M
for j=1:m
    for i=1:n
        f1{i}{j}=binornd(1,1-p(j)); % alleles
        f2{i}{j}=binornd(1,1-p(j));
        m1{i}{j}=binornd(1,1-p(j));
        m2{i}{j}=binornd(1,1-p(j));
        
        if  f1{i}{j}+ f2{i}{j}==0 % father genotype code
            Gf(i,j)=0;
        elseif f1{i}{j}+ f2{i}{j}==1
            Gf(i,j)=1;
        else
            Gf(i,j)=2;
        end
            
        if  m1{i}{j}+ m2{i}{j}==0 % mother genotype
            Gm(i,j)=0;
        elseif m1{i}{j}+ m2{i}{j}==1
            Gm(i,j)=1;
        else
            Gm(i,j)=2;
        end
        
        s1{i}{j}=randsrc(1,1,[f1{i}{j} f2{i}{j}]);  % alleles
        s2{i}{j}=randsrc(1,1,[m1{i}{j} m2{i}{j}]);
        
        if  s1{i}{j}+ s2{i}{j}==0 % offspring genotype code
            Gs(i,j)=0;
        elseif s1{i}{j}+ s2{i}{j}==1
            Gs(i,j)=1;
        else
            Gs(i,j)=2;
        end
     
    end
end

%ͥ״ݣ1Ϊ3࣬2Ϊ4ࣩ
beta1=0.8; %(0.2,0.4,0.6,0.8);
beta2=0.4; %(0.1,0.2,0.3,0.4);
u=[0,0];sigma=[1,0.25;0.25,1];

%inf_trait1=[1,1,0,0,1,1,1,1,1,0,0,0,1,1,1,1,0,1,0,0];
inf_trait1=[1,1,0,0,1,1,1,1,1,0,0,0,1,1,1,1,0,1,0,0,1,0,1,0,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1];
gama1=beta1*inf_trait1;
gama2=beta2*inf_trait1;

feps=mvnrnd(u,sigma,n);
ftemp_trait1=Gf*gama1';
ftemp_trait2=Gf*gama2';
fcont_trait1=ftemp_trait1+feps(:,1); 
fcont_trait2=ftemp_trait2+feps(:,2);

ford_cuting1=quantile(fcont_trait1,[1/2,2/3]);
for j=1:n
if fcont_trait1(j)>=ford_cuting1(2)
   fy1(j)=2;
elseif fcont_trait1(j)>=ford_cuting1(1)
    fy1(j)=1;
else fcont_trait1(j)<=ford_cuting1(1)
     fy1(j)=0;
end
end

ford_cuting2=quantile(fcont_trait2,[1/3,27/50,3/4]);
for j=1:n
    if fcont_trait2(j)>=ford_cuting2(3);
        fy2(j)=3;
    elseif fcont_trait2(j)>=ford_cuting2(2);
        fy2(j)=2;
    elseif fcont_trait2(j)>=ford_cuting2(1);
        fy2(j)=1;
    else fcont_trait2(j)<=ford_cuting2(1);
        fy2(j)=0;
    end
end
fy=[fy1',fy2']; %׵״


meps=mvnrnd(u,sigma,n);
mtemp_trait1=Gm*gama1';
mtemp_trait2=Gm*gama2';
mcont_trait1=mtemp_trait1+meps(:,1); 
mcont_trait2=mtemp_trait1+meps(:,2);

mord_cuting1=quantile(mcont_trait1,[1/2,2/3]);
for j=1:n
if mcont_trait1(j)>=mord_cuting1(2)
   my1(j)=2;
elseif mcont_trait1(j)>=mord_cuting1(1)
    my1(j)=1;
else mcont_trait1(j)<=mord_cuting1(1)
     my1(j)=0;
end
end

mord_cuting2=quantile(mcont_trait2,[1/3,27/50,3/4]);
for j=1:n
    if mcont_trait2(j)>=mord_cuting2(3);
        my2(j)=3;
    elseif mcont_trait2(j)>=mord_cuting2(2);
        my2(j)=2;
    elseif mcont_trait2(j)>=mord_cuting2(1);
        my2(j)=1;
    else mcont_trait2(j)<=mord_cuting2(1);
        my2(j)=0;
    end
end
my=[my1',my2']; %ĸ׵״

seps=mvnrnd(u,sigma,n);
stemp_trait1=Gs*gama1';
stemp_trait2=Gs*gama2';
scont_trait1=stemp_trait1+seps(:,1); 
scont_trait2=stemp_trait2+seps(:,2);

sord_cuting1=quantile(scont_trait1,[1/2,2/3]);
for j=1:n
if scont_trait1(j)>=sord_cuting1(2)
   sy1(j)=2;
elseif scont_trait1(j)>=sord_cuting1(1)
    sy1(j)=1;
else scont_trait1(j)<=sord_cuting1(1)
     sy1(j)=0;
end
end

sord_cuting2=quantile(scont_trait2,[1/3,27/50,3/4]);
for j=1:n
    if scont_trait2(j)>=sord_cuting2(3);
        sy2(j)=3;
    elseif scont_trait2(j)>=sord_cuting2(2);
        sy2(j)=2;
    elseif scont_trait2(j)>=sord_cuting2(1);
        sy2(j)=1;
    else scont_trait2(j)<=sord_cuting2(1);
        sy2(j)=0;
    end
end
sy=[sy1',sy2']; %ӵ״

for i=1:m
nfAA(i)=length(find(Gf(:,i)==2));
nfAa(i)=length(find(Gf(:,i)==1));
nfaa(i)=length(find(Gf(:,i)==0));

nmAA(i)=length(find(Gm(:,i)==2));
nmAa(i)=length(find(Gm(:,i)==1));
nmaa(i)=length(find(Gm(:,i)==0));

nsAA(i)=length(find(Gs(:,i)==2));
nsAa(i)=length(find(Gs(:,i)==1));
nsaa(i)=length(find(Gs(:,i)==0));
end

% nf=[nfAA' nfAa' nfaa'];  %׸λ͸
% nm=[nmAA' nmAa' nmaa'];%ͥĸ׵Ļ͸
% ns=[nsAA' nsAa' nsaa']; %ӵĻ͸

for j=1:n
    for i=1:m
        if Gf(j,i)==2
            nfG(j,i)=nfAA(i);
        elseif Gf(j,i)==1
            nfG(j,i)=nfAa(i);
        else 
            nfG(j,i)=nfaa(i);
        end

        if Gm(j,i)==2
            nmG(j,i)=nmAA(i);
        elseif Gm(j,i)==1
            nmG(j,i)=nmAa(i);
        else 
            nmG(j,i)=nmaa(i);
        end
 
        if Gs(j,i)==2
            nsG(j,i)=nsAA(i);
        elseif Gs(j,i)==1
            nsG(j,i)=nsAa(i);
        else 
            nsG(j,i)=nsaa(i);
        end
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=1:n
lsum(j)=0;
    for i=1:m
    lsum(j)=lsum(j)+log(nfG(j,i)*nmG(j,i)*nsG(j,i));
    end  
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
for i=1:n
    for j=1:n
%         if fy(i,1)-fy(j,1)>0
%             fy(i,1)-fy(j,1)=ones(n,1);
%         elseif fy(i,1)-fy(j,1)=0
%            fy(i,1)-fy(j,1)=zeros(n,1);
%         else 
%             fy(i,1)-fy(j,1)=-ones(n,1);
%         end
        F{i,j}=[sign(fy(i,1)-fy(j,1)) sign(fy(i,2)-fy(j,2)) sign(my(i,1)-my(j,1)) sign(my(i,2)-my(j,2)) sign(sy(i,1)-sy(j,1)) sign(sy(i,2)-sy(j,2))]; 
    end
 end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
for j=1:n
  F_s{1,j}=[0 0 0 0 0 0];
  for i=1:n
  F_s{1,j}=F_s{1,j}+ F{j,i};
  end
end  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%F_bar2=mat2cell(cell2mat(F_s)/200,ones([1,1]),6*ones([200,1]));
F_ba=cell2mat(F_s)/n;
F_bar=reshape(F_ba.',6,[]);
% u_1=[0;0;0;0;0;0];
for j=1:n
u_1(:,j)=lsum(1,j)*F_bar(:,j); 
end
u=(2/(n-1))*sum(u_1');
%ͳu

%%%%%%%%%%%%%%%%%%%λ㺱Ĺֵ%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pf_bar=(nfAa+2*nfaa)/(2*n);
pm_bar=(nmAa+2*nmaa)/(2*n);
ps_bar=(nsAa+2*nsaa)/(2*n);
p_bar=(pf_bar+pm_bar+ps_bar)/3;

for i=1:m
E(i)=3*(log(n)+2*(1-p_bar(i))^2*log(1-p_bar(i))+2*p_bar(i)*(1-p_bar(i))*log(2*p_bar(i)*(1-p_bar(i)))+2*p_bar(i)^2*log(p_bar(i)));
end

for j=1:n
se(:,j)=sum(E)*F_bar(:,j); 
end
E_U=(2/(n-1))*sum(se'); %ͳuֵ

va=zeros(1,m);
for i=1:m
  va(i)=4*p_bar(i)*(1-p_bar(i))^2*(10-7*p_bar(i))*((log(1-p_bar(i)))^2)+2*p_bar(i)*(1-p_bar(i))*(14*(p_bar(i)^2)-14*p_bar(i)+5)*((log(2*p_bar(i)*(1-p_bar(i))))^2)+4*(p_bar(i)^2)*(1-p_bar(i))*(7*p_bar(i)+3)*((log(p_bar(i)))^2)+8*p_bar(i)*((1-p_bar(i))^2)*(7*p_bar(i)-5)*log(1-p_bar(i))*log(2*p_bar(i)*(1-p_bar(i)))+8*(p_bar(i)^2)*(1-p_bar(i))*(2-7*p_bar(i))*log(p_bar(i))*log(2*p_bar(i)*(1-p_bar(i)))-56*(p_bar(i)^2)*((1-p_bar(i))^2)*log(p_bar(i))*log(1-p_bar(i));
end

fsum=zeros(6,6);
for i=1:n
fsum=fsum+F_bar(:,i)*F_bar(:,i)';
end

var_u=(2/(n-1))^2*fsum*sum(va);

w=(u-E_U)*pinv(var_u)*(u-E_U)';
r=rank(pinv(var_u));
W=[W w];

end

E_p=length(find(W>12.591))/M  % type I error rate or Power















